#!/usr/bin/env ruby

=begin

= NikkiGenerator
񂽂LWFl[^H

== Copyright
NARUSE, Yui (((<Airemix|URL:http://www.airemix.com>)))

=end

# ---------------------------------------------- #
require "yaml"

class NikkiGen
  Version = "0.0.2"
  
  attr_accessor :data
  
  def initialize(filename=nil)
    @filename = filename
    @data = Array.new
  end
  
  def load(filename=@filename)
    begin
      File.open(filename,"r") do |file|
	file.flock(File::LOCK_SH)
	hash = YAML::load(file) or return nil
	if hash.is_a?(Hash) then
	  rev = hash["rev"] if hash.key?("rev")
	  @data = hash["data"] if hash.key?("data")
	end
      end
    rescue SystemCallError
    end
  end
  
  def store(filename=@filename)
    File.open(filename,"w") do |file|
      file.flock(File::LOCK_EX)
      file.write({"rev"=>Version,"data"=>@data}.to_yaml)
    end
  end
  
  def generate(i,j)
    @data.empty? and return "ققB"
    data = @data.sort{rand(3)-1}
    
    head = Array.new
    result = Array.new
    data.each do |x|
      if /^(||)/o=~x then head << x else result << x end
    end
    
    str = ""
    if head.empty? then
      str += result.shift + "\n"
    else
      str += head[0] + "\n"
    end
    
    [i*j-1,result.length].min.times do |n|
      str += result[n] + "\n"
      if (n + 2) % j == 0 then str += "\n" end
    end
    return str.chomp
  end
end


# ---------------------------------------------- #
require 'vr/vruby'
require 'vr/vrcontrol'
require 'vr/vrdialog'
require 'vr/vrhandler'

# ------------------------------------ #
module MyForm
  include VRMenuUseable
  include VRClosingSensitive
  
  # --------------------------
  def construct
    @nikkiGen = NikkiGen.new("NikkiData.txt")
    @nikkiGen.load
    tex1text = @nikkiGen.data.join("\r\n")
    
    self.caption="Nikki Generator"
    move 100,100,600,400
    setMenu newMenu.set(
			[ 
			  ["&File",[["E&xit","mexit"]]],
			  ["&Help",[["&About...","about"]]]
			])
    
    addControl VRStatic,"stt1","L̑f", 10, 10,250, 30
    addControl VRText,  "tex1",tex1text,   10, 50,250,220,WStyle::WS_TABSTOP|WStyle::WS_VSCROLL
    addControl VRStatic,"stt2","L",    300, 10,250, 30
    addControl VRText,  "tex2","",        300, 50,250,220,WStyle::WS_TABSTOP|WStyle::WS_VSCROLL
    addControl VRButton,"btn1","Generate", 10,280, 90, 30,WStyle::WS_TABSTOP
  end
  
  # --------------------------
  def tex1_changed; @nikkiGen.data = @tex1.text.split(/\r\n|[\r\n]/o); end
  def btn1_clicked; @tex2.text = @nikkiGen.generate(3,3).gsub(/\n/o,"\r\n").strip; end
  def mexit_clicked; close; end
  def about_clicked; VRLocalScreen.modelessform(self,nil,AboutDialog); end
  def self_close; @nikkiGen.store; end
end

# ------------------------------------ #
module AboutDialog
  def construct
    self.caption="About..."
    move 0,0,150,150
    centering
    addControl VRStatic,"stt1", "Nikki Generator",4,4,170,20
    addControl VRStatic,"stt2", "Version "+NikkiGen::Version,  4,30,170,20
    addControl VRButton,"okbtn","OK",            10,70,100,30,WStyle::WS_TABSTOP
    setButtonAs @okbtn,VRDialogComponent::IDOK
  end
  def okbtn_clicked; close(0); end
end

VRLocalScreen.start(MyForm)
